/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package test.jboss.security.idm;

import java.util.Collection;
import java.util.ArrayList;
import java.lang.reflect.Method;

import org.apache.cactus.*;


import org.jboss.security.idm.Identity;
import org.jboss.security.idm.ProvisioningProvider;
import org.jboss.security.idm.IdentityManager;

/**
 * 
 * @author Sohil Shah - sohil.shah@jboss.com
 *
 */
public class RegisterTestCase extends ServletTestCase
{
    /**
     * 
     * @throws Exception
     */
    public void test() throws Exception
    {
       System.out.println("Register User....................................");
       
       ProvisioningProvider provider = IdentityManager.findProvisioningProvider();
       
       Identity identity = new Identity();
       identity.setUserName("passwordTester");
       identity.setPassword("password2006".getBytes());
       identity.setEmail("sohil.shah@jboss.com");
       identity.setActive(true);
       identity.setFullName("Sohil Shah");
       identity.setCompanyName("JBoss, Inc");
       identity.setCompanyRole("Developer");
       identity.setCompanyTitle("Web Infrastructure Developer");       
       identity.addEmail("soshah@hotmail.com");
       identity.addEmail("soshah@gmail.com");
       
       //address data       
       identity.getCompanyAddress().setStreet("5261 Wellsley Bend ");
       identity.getCompanyAddress().setState("GA");
       identity.getCompanyAddress().setCity("Alpharetta");
       identity.getCompanyAddress().setPostalCode("30005");
       identity.getCompanyAddress().setCountry("USA");
       
       identity.addPhoneNumber("770-663-0679");
       identity.addPhoneNumber("404-229-6897");
       
       
       provider.register(identity);
       
       
       //assertNotNull(identity);
                     
       System.out.println("(Done)..........................................."); 
    }
}
